import es
import time

Max_Uses    = 3    # How many times a user can double jump. Resets when he lands. (0 = None, -1 = infinite)
Push_Value  = 375   # How hard to push the user
Intervals   = 0.3   # Minimum time between each jump. (In seconds)

JumpsUsed           = {}
JumpsUsed['count']  = {}
JumpsUsed['time']   = {}

def load():
    es.msg("#multi","\x05[CDJ] #greenCheeTaHs Double Jump #defaulthas been loaded!")
    PubVar = es.ServerVar("cdj_version","1.0CheeTaH-Public","Script Version")
    PubVar.set("1.0CheeTaH-Public")
    PubVar.makepublic()

def unload():
    es.msg("#multi","\x05[CDJ] #greenCheeTaHs Double Jump #defaulthas been unloaded!")


def player_jump(ev):
    userid = ev['userid']
    JumpsUsed['count'][userid] = 0
    JumpsUsed['time'][userid] = 0


def sm2es_keyPress(ev):
    if not int(ev['status']):
        return
    if ev['command'] != 'IN_JUMP':
        return
    
    userid = ev['userid']
    newTime = time.time()
    
    if userid not in JumpsUsed['time'] or userid not in JumpsUsed['count']:
        player_jump(ev)
        return
        
    if JumpsUsed['count'][userid] > Max_Uses and Max_Uses != -1:
        return
       
    timeBetween = newTime - JumpsUsed['time'][userid]
    if timeBetween > Intervals:
        if JumpsUsed['count'][userid] > 0:
            es.setplayerprop(ev['userid'],"CCSPlayer.baseclass.localdata.m_vecBaseVelocity", "0,0,%s" %Push_Value)
        
        JumpsUsed['time'][userid] = newTime
        JumpsUsed['count'][userid] += 1